import sys
from itertools import product

[n, h] = [int(i) for i in input().split(' ')]


def roll_dice(x):
    outcomes = list(product(range(1, 7), repeat=x))
    return outcomes


def calculate_probabilities(x):
    outcomes = roll_dice(x)
    total_outcomes = len(outcomes)
    probabilities = {}
    for outcome in outcomes:
        sum_outcome = sum(outcome)
        if sum_outcome in probabilities:
            probabilities[sum_outcome] += 1
        else:
            probabilities[sum_outcome] = 1
    return probabilities, total_outcomes


coins = 0
for line in sys.stdin:
    [t, x] = [int(i) for i in line.split(' ')]
    if t == 1:
        coins += 1
    else:
        probabilities, total_outcomes = calculate_probabilities(coins)
        possible_probabilities = [
            v for k, v in probabilities.items() if k + x >= h]
        print(sum(possible_probabilities) / total_outcomes)
        exit(0)
print(0)
exit(0)
